/*
** $Header: /u/spert/src/fltvec/php/RCS/vecele.c,v 1.4 1995/10/13 00:17:00 davidj Exp $
**
** Element wise vector operations - portably optimized
*/

#include <fltv-config.h>
#include <stddef.h>
#include <fltv-defs.h>
#include <fltv-scansrc.h>

/*** vector/scalar ops ***/

/* TODO - this is not necessarily the best inlined version,
**        but rather a quick hack to make sure this works
*/

#ifdef DEL_php_copy_f_vf
void php_copy_f_vf(size_t len, float from, float* to);
#endif


#if defined(DEFN_php_copy_f_vf)
void
php_copy_f_vf(size_t len, float from, float* to)
{
    register size_t i;
    register const from_val = from; 

    for (i=0; i < (len>>2); i++)
    {
	*to = from_val;
	*(to+1) = from_val;
	*(to+2) = from_val;
	*(to+3) = from_val;
	to += 4;
    }
    for (i=0; i<(len & 0x03); i++)
    {
	*to++ = from_val;
    }
}
#endif
